Attribute VB_Name = "mTableSelector"
Option Explicit
'==========================================================
'           Copyright Information
'==========================================================
'Program Name: Mewsoft Table Selector ActiveX Control
'Program Author   : Elsheshtawy, A. A.
'Home Page        : http://www.mewsoft.com
'Copyrights  2006 Mewsoft Corporation. All rights reserved.
'
' We Provide Full Featured Open Source Code Products:
'   Auction Software        - Run your own auction site in minutes
'   Classifieds Software    - Run your own classifieds site
'   Directory and Pay Per Click Search Engine Software
'   Forum and Buliten Board System Software
'   Traffic Builder Software
'   Site Builder and Content Managment Software
'   Backupawy - Backup you website and servers automatically, Never loose your sites again
'   Validawy  - Live validate and filter your mail lists with this 500 multi-threaded validator
'   Lots or free ActiveX and VB Open Source Products
'   For download, support, details, please check our website:
'                   http://www.mewsoft.com
'==========================================================
'==========================================================
' To draw the window:
Public Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Public Type POINTAPI
   X As Long
   Y As Long
End Type

Private Declare Function GetSysColorBrush Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Const COLOR_ACTIVEBORDER = 10
Private Const COLOR_ACTIVECAPTION = 2
Private Const COLOR_ADJ_MAX = 100
Private Const COLOR_ADJ_MIN = -100  'shorts
Private Const COLOR_APPWORKSPACE = 12
Private Const COLOR_BACKGROUND = 1
Private Const COLOR_BTNFACE = 15
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNSHADOW = 16
Private Const COLOR_BTNTEXT = 18
Private Const COLOR_CAPTIONTEXT = 9
Private Const COLOR_GRAYTEXT = 17
Private Const COLOR_HIGHLIGHT = 13
Private Const COLOR_HIGHLIGHTTEXT = 14
Private Const COLOR_INACTIVEBORDER = 11
Private Const COLOR_INACTIVECAPTION = 3
Private Const COLOR_INACTIVECAPTIONTEXT = 19
Private Const COLOR_MENU = 4
Private Const COLOR_MENUTEXT = 7
Private Const COLOR_SCROLLBAR = 0
Private Const COLOR_WINDOW = 5
Private Const COLOR_WINDOWFRAME = 6
Private Const COLOR_WINDOWTEXT = 8
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Const PS_SOLID = 0
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function DrawStatusText Lib "COMCTL32" Alias "DrawStatusTextA" (ByVal hdc As Long, lprc As RECT, ByVal pszText As String, ByVal uFlags As Long) As Long

Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal lColor As Long) As Long
Public Declare Function CreateHatchBrush Lib "gdi32" (ByVal fnStyle As Integer, ByVal COLORREF As Long) As Long

'Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)

Private m_lCurrentX As Long
Private m_lCurrentY As Long

'uFlags text drawing operation values:
'also used by SB_SETTEXT, SB_SETTEXT, SB_GETTEXTLENGTH below
'The text is drawn with a border to appear lower
'than the plane of the window.
Public Const SBT_SUNKEN As Long = &H0  'Default
'The text is drawn without borders.
Public Const SBT_NOBORDERS As Long = &H100
'The text is drawn with a border to appear higher
'than the plane of the window.
Public Const SBT_POPOUT As Long = &H200
'SB_SETTEXT, SB_SETTEXT, SB_GETTEXTLENGTH flags only:
'Displays text using right-to-left reading order on
'Hebrew or Arabic systems.
Public Const SBT_RTLREADING As Long = &H400
'The text is drawn by the parent window.
Public Const SBT_OWNERDRAW As Long = &H1000

'Hatched Brush Constants
'Public Const HS_HORIZONTAL = 0
'Public Const HS_VERTICAL = 1
'Public Const HS_FDIAGONAL = 2
'Public Const HS_BDIAGONAL = 3
'Public Const HS_CROSS = 4
'Public Const HS_DIAGCROSS = 5

Public Enum CellFillStyleX
    HS_HORIZONTAL = 0
    HS_VERTICAL = 1
    HS_FDIAGONAL = 2
    HS_BDIAGONAL = 3
    HS_CROSS = 4
    HS_DIAGCROSS = 5
    HS_Solid = 6 ' add this custom type for solid fill
End Enum

Public m_lCellWidth As Long
Public m_lCellHeight As Long
Public m_lStartRows As Long
Public m_lStartColumns As Long
Public m_lInCellFillStyle As Long
Public m_lCellFillStyle As Long
Public m_lCellBackColor As Long
Public m_lInCellBackColor As Long
Public m_lBackColor As Long
Public m_lStatusBackColor As Long
Public m_oStatusFont As New StdFont
Public PicStatusText As PictureBox
Public m_lBorderColor As Long
Public m_lHiBorderColor As Long
Public m_sStatusFormat As String
Public m_sStatusCancel As String
Public m_bStatusRightToLeft As Boolean
Public m_lCellSpacing As Long
Public m_lCellBorderSize As Long
Public m_lCellBorderColor As Long

Public m_lMaxRows As Long
Public m_lMaxCols As Long

Public m_lObjCallUserControl As Long

'====================================================================
'====================================================================
Public Sub DefaultSize(ByRef picDropDown As PictureBox, ByRef PicStatus As PictureBox)
    
    picDropDown.Width = (6 + m_lCellWidth * m_lStartColumns) * Screen.TwipsPerPixelX
    picDropDown.Height = (6 + m_lCellHeight * m_lStartRows + m_lCellHeight) * Screen.TwipsPerPixelY
    picDropDown.BackColor = m_lBackColor
    
    Set picDropDown.Font = m_oStatusFont
    picDropDown.Cls
    
    Set PicStatus.Font = m_oStatusFont
    PicStatus.Cls
    Set PicStatusText = PicStatus
    
    'picDropDown.RightToLeft = True
End Sub

'====================================================================
Public Sub Draw( _
                   ByRef cDW As cDropDownToolWindow, _
                   ByVal xPixels As Long, _
                   ByVal yPixels As Long, _
                   ByVal button As MouseButtonConstants, _
                   Optional ByRef bIn As Boolean, _
                   Optional ByRef xCellHit As Long, _
                   Optional ByRef yCellHit As Long _
                )
   
    Dim tR As RECT
    Dim tWR As RECT
    Dim tJunk As POINTAPI
    Dim lHDC As Long
    Dim hPen As Long, hPenOld As Long
    Dim bInX As Boolean, bInY As Boolean
    Dim hBrIn As Long, hBrOut As Long, hBr As Long
    Dim X As Long, Y As Long, tBoxR As RECT
    Dim xMax As Long, yMax As Long, sStatus As String
    Dim bResize As Boolean
   
    ' This example uses API methods to draw on the
    ' PictureBox. But you don't have to use API
    ' methods, VB drawing methods work just as well
    ' and seem to be very quick these days.
    
    
    ' Get size of pic
    GetClientRect cDW.DropDownObject.hwnd, tR
      
    ' Cache HDC for speed:
    lHDC = cDW.DropDownObject.hdc
    
    'cDW.DropDownObject.RightToLeft = True
    
    ' The client area:
    If cDW.InRect(xPixels * Screen.TwipsPerPixelX, yPixels * Screen.TwipsPerPixelY) Then
        ' in.  Caption is cancel and boxes up to xPixels,yPixels are highlighted:
        bIn = True
    Else
        ' not in.  Caption is cancel and all boxes are blank
        ' either we exceed in x or y and thus should increase size..
        If (button = vbLeftButton) Then
           If xPixels > tR.Right Then
                If m_lMaxCols > 0 Then
                    xCellHit = (tR.Right - tR.Left) \ m_lCellWidth
                    If xCellHit < m_lMaxCols Then
                        'Increase columns
                        tR.Right = tR.Right + m_lCellWidth
                        bResize = True
                    Else
                        bResize = False
                    End If
                    'Debug.Print "m_lMaxCols > 0 "; m_lMaxCols
                Else
                    'Increase columns
                    tR.Right = tR.Right + m_lCellWidth
                    bResize = True
                    'Debug.Print "m_lMaxCols < 0 "; m_lMaxCols
                End If
           End If
    
           If yPixels > tR.Bottom Then
                If m_lMaxRows > 0 Then
                    yCellHit = (tR.Bottom - tR.Top - m_lCellHeight) \ m_lCellHeight
                    If yCellHit < m_lMaxRows Then
                        'Increase rows
                        tR.Bottom = tR.Bottom + m_lCellHeight
                        bResize = True
                    Else
                        bResize = False
                    End If
                     'Debug.Print "m_lMaxRows > 0"
                Else
                    'Debug.Print "m_lMaxRows < 0"
                    'Increase rows
                    tR.Bottom = tR.Bottom + m_lCellHeight
                    bResize = True
                End If
           
           End If
           
           xCellHit = 0
           yCellHit = 0
           
           If bResize Then
              cDW.Resize tR.Right - tR.Left, tR.Bottom - tR.Top
              ' HDC has changed:
              lHDC = cDW.DropDownObject.hdc
              ' Clear the area:
              LSet tWR = tR
              tWR.Right = tWR.Right + 3
              tWR.Bottom = tWR.Bottom + 3
              
              'hBr = GetSysColorBrush(COLOR_BTNFACE)
              hBr = CreateSolidBrush(m_lBackColor)
              FillRect lHDC, tWR, hBr
              DeleteObject hBr
           End If
           bIn = bResize
        Else
           bIn = False
        End If
    End If
        
    ' Draw the border to the drop down window:
    'hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    hPen = CreatePen(PS_SOLID, 1, m_lBorderColor)
    hPenOld = SelectObject(lHDC, hPen)
    Rectangle lHDC, tR.Left, tR.Top, tR.Right, tR.Bottom
    SelectObject lHDC, hPenOld
    DeleteObject hPen
    
    MoveToEx lHDC, 1, tR.Bottom - 2, tJunk
    
    'hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    hPen = CreatePen(PS_SOLID, 1, m_lHiBorderColor)
    
    hPenOld = SelectObject(lHDC, hPen)
    LineTo lHDC, 1, tR.Top + 1
    LineTo lHDC, tR.Right - 1, tR.Top + 1
    SelectObject lHDC, hPenOld
    DeleteObject hPen
    
    ' Modify the client rectangle to exclude the
    ' border and the "status bar"
    
    'InflateRect tR, -6,  -27
    InflateRect tR, -6, -m_lCellHeight - 3
    'OffsetRect  tR, -3, -24
    OffsetRect tR, -3, -m_lCellHeight
    
    ' Set up a selected and non-selected brush:
    'hBrIn = GetSysColorBrush(COLOR_HIGHLIGHT)
    'hBrOut = GetSysColorBrush(COLOR_WINDOW)
    
    If m_lInCellFillStyle >= 0 And m_lInCellFillStyle <= 5 Then
        hBrIn = CreateHatchBrush(m_lInCellFillStyle, m_lInCellBackColor)
    Else
        hBrIn = CreateSolidBrush(m_lInCellBackColor)
    End If
    
    If m_lCellFillStyle >= 0 And m_lCellFillStyle <= 5 Then
        hBrOut = CreateHatchBrush(m_lCellFillStyle, m_lCellBackColor)
    Else
        hBrOut = CreateSolidBrush(m_lCellBackColor)
    End If
    
    ' Draw the table cells to pick from, highlighting
    ' the ones the mouse has "selected":
    For X = tR.Left To tR.Right Step m_lCellWidth
        tBoxR.Left = X + 1
        tBoxR.Right = X + m_lCellWidth - m_lCellSpacing
        If (xPixels >= tBoxR.Left) Then
           bInX = True
        Else
           bInX = False
        End If
        For Y = tR.Top To tR.Bottom Step m_lCellHeight
           tBoxR.Top = Y + 1
           tBoxR.Bottom = Y + m_lCellHeight - m_lCellSpacing
           If (yPixels > tBoxR.Top) Then
              bInY = True
           Else
              bInY = False
           End If
           If (bIn And bInX And bInY) Then
              hBr = hBrIn
              If (X > xMax) Then
                 xMax = X
              End If
              If (Y > yMax) Then
                 yMax = Y
              End If
           Else
              hBr = hBrOut
           End If
           FillRect lHDC, tBoxR, hBr
         
            ' Draw the cell border
            hPen = CreatePen(PS_SOLID, m_lCellBorderSize, m_lCellBorderColor)
            hPenOld = SelectObject(lHDC, hPen)
            Rectangle lHDC, tBoxR.Left + 0, tBoxR.Top + 0, tBoxR.Right - 0, tBoxR.Bottom - 0
            SelectObject lHDC, hPenOld
            DeleteObject hPen
      Next Y
    Next X
    
    DeleteObject hBrIn
    DeleteObject hBrOut
    '-----------------------------------------------------------------
    ' Draw the "status bar"
    '-----------------------------------------------------------------
    Set cDW.DropDownObject.Font = m_oStatusFont
    'cDW.DropDownObject.BackColor = vbRed
    '-----------------------------------------------------------------
    tR.Left = tR.Left + 1
    tR.Right = tR.Right + 6
    'tR.Top = tR.Bottom + 27
    'tR.Bottom = tR.Top + 20
    tR.Top = tR.Bottom + m_lCellHeight + 3
    tR.Bottom = tR.Top + m_lCellHeight - 4
    
    If (bIn) Then
      xCellHit = xMax \ m_lCellWidth + 1
      yCellHit = yMax \ m_lCellHeight + 1
      m_lCurrentX = xCellHit
      m_lCurrentY = yCellHit
      
      'sStatus = xCellHit & " by " & yCellHit & " table"
      sStatus = m_sStatusFormat
      sStatus = Replace(sStatus, "%R%", yCellHit)
      sStatus = Replace(sStatus, "%C%", xCellHit)
    Else
      m_lCurrentX = 0
      m_lCurrentY = 0
      'sStatus = "Cancel"
      sStatus = m_sStatusCancel
    End If
    
    Dim TxtWidth As Long, TxtHeight As Long
    Dim PosX As Long, PosY As Long
    
    TxtWidth = PicStatusText.TextWidth(sStatus)
    TxtHeight = PicStatusText.TextHeight(sStatus)
   
    PosX = (cDW.DropDownObject.Width - TxtWidth) \ 2
    PosY = ((m_lCellHeight - 4) * Screen.TwipsPerPixelY - TxtHeight) \ 2
   
'    DrawStatusText lHDC, tR, sStatus, SBT_NOBORDERS
'    cDW.DropDownObject.CurrentX = tR.Left * Screen.TwipsPerPixelX
'    cDW.DropDownObject.CurrentY = tR.Top * Screen.TwipsPerPixelY
'    cDW.DropDownObject.Print sStatus
    'Set status text direction
    PicStatusText.RightToLeft = m_bStatusRightToLeft
    
    PicStatusText.Move _
                tR.Left * Screen.TwipsPerPixelX, _
                tR.Top * Screen.TwipsPerPixelY, _
                Abs(cDW.DropDownObject.Width - (8 * Screen.TwipsPerPixelX)), _
                Abs(m_lCellHeight - 4) * Screen.TwipsPerPixelY
                
    PicStatusText.BackColor = m_lStatusBackColor
    PicStatusText.Cls
    
    PicStatusText.CurrentX = PosX '* Screen.TwipsPerPixelX
    PicStatusText.CurrentY = PosY '1 * Screen.TwipsPerPixelY
    PicStatusText.Print sStatus
    PicStatusText.Refresh
    
    ' Show the changes on screen:
    cDW.DropDownObject.Refresh
   
End Sub

'====================================================================
Public Sub KeyEffect(ByVal iKey As KeyCodeConstants, ByRef bDoIt As Boolean, ByRef X As Single, ByRef Y As Single, ByRef eButton As MouseButtonConstants, ByRef bCancel As Boolean, ByRef bSelect As Boolean)
   
    bDoIt = False
    
    X = (m_lCurrentX - 1) * m_lCellWidth + 3
    Y = (m_lCurrentY - 1) * m_lCellHeight + 3
    
    eButton = vbLeftButton
    bCancel = False
    bSelect = False
    
    Select Case iKey
         Case vbKeyUp
            bDoIt = True
            Y = Y - m_lCellHeight
            If (Y < 0) Then Y = 0
         Case vbKeyDown
            bDoIt = True
            Y = Y + m_lCellHeight
         Case vbKeyRight
            bDoIt = True
            X = X + m_lCellWidth
         Case vbKeyLeft
            bDoIt = True
            X = X - m_lCellWidth
            If (X < 0) Then X = 0
         Case vbKeyReturn, vbKeySpace
            bDoIt = True
            bSelect = True
         Case vbKeyEscape
            bDoIt = True
            bCancel = True
    End Select
    
End Sub

'====================================================================
'                     Calling UserControl Events
'====================================================================
'http://www.experts-exchange.com/Programming/Programming_Languages/Visual_Basic/VB_Controls/Q_20360391.html
Public Property Let CallUserControl(ByVal nCtrl As TableSelector)
   m_lObjCallUserControl = ObjPtr(nCtrl)
End Property

Public Property Set CallUserControl(ByVal nCtrl As TableSelector)
   m_lObjCallUserControl = ObjPtr(nCtrl)
End Property

Public Property Get CallUserControl() As TableSelector
   
   Dim ct As TableSelector
   If (m_lObjCallUserControl <> 0) Then
        CopyMemory ct, m_lObjCallUserControl, 4
        Set CallUserControl = ct
        CopyMemory ct, 0&, 4
    Else
        Set CallUserControl = Nothing
   End If
   
End Property

Public Sub RaiseTableSelectedEvent(ByVal Rows As Long, ByVal Cols As Long, bCancel As Boolean)
    If Not CallUserControl Is Nothing Then
        CallUserControl.EventTableSelected Rows, Cols, bCancel
    End If
End Sub

Public Sub RaiseTableSelectionChangedEvent(ByVal Rows As Long, ByVal Cols As Long, bCancel As Boolean)
    If Not CallUserControl Is Nothing Then
        CallUserControl.EventTableSelectionChanged Rows, Cols, bCancel
    End If
End Sub
'====================================================================
'====================================================================

